import java.awt.*;
import java.applet.*;

public class ImageBarMeterApplet2 extends BarMeterApplet {

    // `pC[W
    protected Image foregroundImage = null;

    // wipC[W
    protected Image backgroundImage = null;

    public void init(){
        // HTMLlo
        minimum = Double.valueOf(getParameter("minimum")).doubleValue();
        maximum = Double.valueOf(getParameter("maximum")).doubleValue();

        //  DataCreator ̎ނo
        dataCreatorName = getParameter("data");
        try{
            // DataCreator ̐
            Class dataCreatorClass = Class.forName(dataCreatorName);
            dataCreator = (DataCreator)dataCreatorClass.newInstance();
        }catch(ClassNotFoundException ex){
            System.err.println("Can't found such a class!");
            System.exit(1);
        }catch(InstantiationException ex){
            System.err.println("Can't instance such a class!");
            System.exit(1);
        }catch(IllegalAccessException ex){
            System.err.println("Can't instance such a class!");
            System.exit(1);
        }


        // C[W̓ǂݍ
        String filename = getParameter("image");
        foregroundImage = getImage(getDocumentBase(), filename);

        // wiC[W̓ǂݍ
        filename = getParameter("background");
        backgroundImage = getImage(getDocumentBase(), filename);

        MediaTracker tracker = new MediaTracker(this);
        tracker.addImage(foregroundImage, 0);
        tracker.addImage(backgroundImage, 0);
        try{
            // C[W[h܂ő҂
            tracker.waitForID(0);
        }catch(InterruptedException e){
            System.exit(1);
        }
    }

    // o[̕`
    protected void drawBar(Graphics g, double value){
        
        // wl̑ΒlZo
        double val = (value - minimum)/ (maximum - minimum);

        // Ot̍ɕϊ
        val *= height;

        int h = (int)val;

        g.clearRect(0, 0, width, height);

        // C[W`
        g.drawImage(foregroundImage, 0, 0, this);

        if(h != 0){
            // wiC[W̕`
            Image bimage = this.createImage(width, h);
            Graphics bg = bimage.getGraphics();
            bg.drawImage(backgroundImage, 0, 0, this);

            g.drawImage(bimage, 0, 0, this);
        }
    }

    public void paint(Graphics g){

        // _uobt@Op̃C[WȂ΁A
        // AOtBbNReLXgB
        if(image == null){
            // Avbg̃TCY
            Dimension size = this.getSize();
            width = size.width;
            height = size.height;
            
            // C[W̐
            image = this.createImage(width, height);
            graphics = image.getGraphics();
        }
        
        // o[̕`
        drawBar(graphics, value);

        // C[Wobt@̕`
        g.drawImage(image, 0, 0, width, height, this);
    }
}
